﻿using System;
using System.ComponentModel;
using System.Linq.Expressions;
using System.Runtime.CompilerServices;

namespace WpfControls
{
    public class ViewModelBase : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        public virtual void FirePropertyChanged(string aPropertyName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(aPropertyName));
        }

		public virtual void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
		{
			this.FirePropertyChanged(propertyName);
		}

        #endregion

    }
}
