﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
//using System.Data.Linq;
using System.Globalization;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Markup;
using Infragistics;
using Infragistics.Controls.Charts;
using Infragistics.Windows;

namespace WpfControls
{
	/// <summary>
	/// Interaction logic for WPFBarChartUC.xaml
	/// </summary>
	public partial class WPFBarChartUC : UserControl
	{
		List<Marker> MarkerSeries;

		public WPFBarChartUC()
		{
			InitializeComponent();
		}

		public void XamStackedBarChartSeries_OnSeriesCreated(object sender, StackedSeriesCreatedEventArgs seriesCreatedEventArgs)
		{

			var mSeries = (StackedFragmentSeries)sender;

//			var mXaml =
//			@"<DataTemplate x:Key='StackedBarMarkerTemplate'
//					xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation' 
//					xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml'>
//                <TextBlock Margin='0,0,0,0' Visibility='{Binding Path=Item.MarkerVisibility}'
//								Text='{Binding Path=Item." + mSeries.ValueMemberPath + @", StringFormat=0}'
//								TextAlignment='Left'
//								FontSize='11' FontWeight='Bold'
//								Foreground='Black'>
//				</TextBlock>
//			</DataTemplate>";

			//var mMarkerTemplate = XamlReader.Parse(mXaml) as DataTemplate;
			//seriesCreatedEventArgs.MarkerTemplate = mMarkerTemplate;

			mSeries.Title = mSeries.ValueMemberPath.Replace("_Value", string.Empty);
		}

		private void XamStackedBarChartSeries_OnLoaded(object sender, RoutedEventArgs e)
		{
			//var mSeries = sender as StackedBarSeries;
			//if (mSeries == null)
			//	return;

			//var mRootCanvas = mSeries.RootCanvas;
			
			//MarkerSeries = new List<Marker>();
			//Marker marker = Utilities.GetDescendantFromType(sender as DependencyObject, typeof(Marker), false) as Marker;
			//if (marker != null && marker.Parent.GetType() == typeof(Canvas))
			//{
			//	Canvas canvas = marker.Parent as Canvas;
			//	canvas.HorizontalAlignment = HorizontalAlignment.Center;
			//	//canvas.SetValue(Canvas.LeftProperty, 100.0);
			//	//canvas.SetValue(Canvas.TopProperty, 10.0);

			//	var mval = canvas.RenderTransform;

			//	foreach (var item in canvas.Children)
			//	{
			//		if (item is Marker)
			//		{
			//			MarkerSeries.Add((Marker)item);
			//			//if (((Marker)item).RenderTransform.Value.OffsetX <= 0)
			//			//{
			//			//	((Marker)item).Visibility = Visibility.Collapsed;
			//			//}
			//		}
			//	}
			//}
		}
	}

	public class ChartDataItem
	{
		public string Text { get; set; }
		public string Value { get; set; }
		public string Title { get; set; }
		public string Typ { get; set; }



		public string TooltipText { get; set; }

		public Visibility MarkerVisibility
		{
			get { return (this.Value == "0") ? Visibility.Collapsed : Visibility.Visible; }
		}

		public ChartDataItem()
		{
			this.Text = string.Empty;
			this.Value = string.Empty;
			this.Title = String.Empty;
			this.Typ = String.Empty;

			this.TooltipText = string.Empty;
		}

		public ChartDataItem(DataRow aDataRow, string aCategoryColumnName = "text", string aValueColumnName = "value", string aTypColumnName = "typ", bool aUseShortName = false)
			:this()
		{
			if (aUseShortName)
				this.Text = GetAbkuerzungFor(aDataRow, aDataRow[aCategoryColumnName] as string ?? string.Empty);
			else
				this.Text = aDataRow[aCategoryColumnName] as string ?? string.Empty;


			this.Value = (aDataRow.Table.Columns.Contains(aValueColumnName)) ? 
				aDataRow[aValueColumnName] as string : string.Empty;

			this.Typ = (aDataRow.Table.Columns.Contains(aTypColumnName)) ?
				aDataRow[aTypColumnName] as string : string.Empty;

			this.TooltipText = aDataRow[aCategoryColumnName] as string ?? this.Text;
		}

		public ChartDataItem(DataRow aDataRow, string aCategoryColumnName, Dictionary<string, string> aValueColumnNames, bool aUseShortName = false)
		{
			if (aUseShortName)
				this.Text = GetAbkuerzungFor(aDataRow, aDataRow[aCategoryColumnName] as string ?? string.Empty);
			else
				this.Text = aDataRow[aCategoryColumnName] as string ?? string.Empty;

			int i = 0;
			foreach (var mEach in aValueColumnNames)
			{
				var mVar = i == 0 ? String.Empty : (i + 1).ToString();
				var mValuePropertyInfo = this.GetType().GetProperty("Value" + mVar);
				var mTitlePropertyInfo = this.GetType().GetProperty("Title" + mVar);

				mValuePropertyInfo.SetValue(this, aDataRow[mEach.Key] as string ?? string.Empty);
				mTitlePropertyInfo.SetValue(this, mEach.Value ?? string.Empty);
				i++;
			}

			this.TooltipText = aDataRow[aCategoryColumnName] as string ?? this.Text;
		}

		private string GetAbkuerzungFor(DataRow aDataRow, string aString)
		{
			string schluesselNr = aDataRow["SCHLUESSEL_NR"].ToString();
			string returnString = aString.Replace("(" + schluesselNr + ")", "");

			if (returnString.Length > 16)
			{
				returnString = aString.Substring(0, 16);
				returnString = returnString + "...(" + schluesselNr + ")";
			}
			else
				returnString = aString;
			return returnString;
		}
	}



	public class ChartsViewModel : ViewModelBase
	{
		public GroupBy StackedBarData { get; set; }

		public int ItemsCount
		{
			get { return this.DataItems.Count(); }
		}

		public IEnumerable ItemsSource
		{
			get { return this.DataItems; }
		}

		private IEnumerable<ChartDataItem> iDataItems;
		public IEnumerable<ChartDataItem> DataItems
		{
			get
			{
				if (this.IsStackedBarChart)
					return this.StackedBarData.ItemsSource.Cast<ChartDataItem>();

				return this.iDataItems;
			}
			set
			{
				if (this.IsStackedBarChart)
					this.StackedBarData.ItemsSource = value;
				else
					this.iDataItems = value;
				this.NotifyPropertyChanged();
			}
		}

		private string iHeaderText;
		public string HeaderText
		{
			get { return this.iHeaderText; }
			set
			{
				this.iHeaderText = value;
				this.NotifyPropertyChanged();
				this.FirePropertyChanged("HeaderTextVisibility");
			}
		}

		private string iFooterText;
		public string FooterText
		{
			get { return this.iFooterText; }
			set
			{
				this.iFooterText = value;
				this.NotifyPropertyChanged();
				this.FirePropertyChanged("FooterTextVisibility");
			}
		}

		private string iTitle;
		public string Title
		{
			get { return iTitle; }
			set
			{
				iTitle = value;
				NotifyPropertyChanged();
			}
		}

		public string TooltipText { get; set; }

		public Visibility FooterTextVisibility
		{
			get { return (string.IsNullOrEmpty(this.FooterText)) ? Visibility.Collapsed : Visibility.Visible; }
		}

		public Visibility HeaderTextVisibility
		{
			get { return (string.IsNullOrEmpty(this.HeaderText)) ? Visibility.Collapsed : Visibility.Visible; }
		}

		public Visibility LegendVisibility { get; set; }

		public Visibility StackedBarChartVisibility
		{
			get { return this.IsStackedBarChart ? Visibility.Visible : Visibility.Hidden; }
		}

		public Visibility BarChartVisibility
		{
			get { return this.IsStackedBarChart ? Visibility.Hidden : Visibility.Visible; }
		}

		private bool iIsStackedBarChart;

		public bool IsStackedBarChart
		{
			get { return this.iIsStackedBarChart; }
			set
			{
				this.iIsStackedBarChart = value;
				this.FirePropertyChanged("StackedBarChartVisibility");
				this.FirePropertyChanged("BarChartVisibility");
			}
		}

		private double iMaxValue = double.NaN;
		public double MaxValue
		{
			get
			{
				var mVariableExtent = 30.0;

				if (double.IsNaN(this.iMaxValue))
				{
					if (this.DataItems.Any())
					{
						this.iMaxValue = this.IsStackedBarChart ? this.DataItems.GroupBy(X => X.Typ).Select(X => X.Sum(Each => Convert.ToDouble(Each.Value))).Max() 
							: this.DataItems.Select(item => double.Parse(item.Value)).Max();
					}
					else
						this.iMaxValue = 0.0;
				}

				if (this.iMaxValue < 10)
					mVariableExtent = 5.0;
				else if (this.iMaxValue < 50)
					mVariableExtent = 10.0;
				else if (this.iMaxValue < 200)
					mVariableExtent = 20.0;
				

				return (this.iMaxValue + mVariableExtent);
			}
		}

		/// <summary>
		/// Dient dazu, dass bei einem MaxValue von 10 immer in Einerschritten und nicht mit 0.5er angezeigt wird.
		/// Sobald der Wert größer wird NaN geliefert, das bewirkt, dass die Intervallanpassung automatisch geschieht.
		/// </summary>
		public double Interval
		{
			get
			{
				return this.MaxValue < 10.0 ? 1 : double.NaN;
			}
		}

		public ChartsViewModel()
		{
			this.IsStackedBarChart = false;
			this.DataItems = new ObservableCollection<ChartDataItem>();
		}

		public ChartsViewModel(DataSet aDataSet, string aTableNameDataItems, bool aStackedChart = false, string aCategoryColumnName = "text", string aValuesColumnName = "value", string aTypeColumnName = "typ", bool aUseShortName = false)
			: this(aDataSet.Tables[aTableNameDataItems], aStackedChart, aCategoryColumnName, aValuesColumnName, aTypeColumnName, aUseShortName)
		{
		}

		public ChartsViewModel(DataTable aDataTable, bool aStackedChart = false, string aCategoryColumnName = "text", string aValuesColumnName = "value", string aTypeColumnName = "typ", bool aUseShortName = false)
		{
			this.IsStackedBarChart = aStackedChart;
			var mGroupBy = new GroupBy
			{
				KeyMemberPath = "Typ",
				ValueMemberPath = "Value",
				GroupMemberPath = "Text"
			};

			var mDataItems = new ObservableCollection<ChartDataItem>();
			if (aDataTable != null)
			{
				mDataItems = new ObservableCollection<ChartDataItem>(aDataTable
						.AsEnumerable()
						.Select(mRow => new ChartDataItem(mRow, aCategoryColumnName, aValuesColumnName, aTypeColumnName))
						.ToList());
			}

			if (IsStackedBarChart)
			{
				mGroupBy.ItemsSource = mDataItems;
				this.StackedBarData = mGroupBy;
			}
			else
			{
				this.DataItems = mDataItems;
			}
		}
	}

	public class ChartsKeyConverter : IValueConverter
	{

		public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			if (value is string && parameter is string)
			{
				var key = (string)value;
				var param = (string)parameter;

				key = key.Replace(param, "");

				return key;
			}

			return "";
		}

		public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}

	public class GroupingBaseToValueConverter : IMultiValueConverter
	{
		public object Convert(object[] aValues, Type aTargetType, object aParameter, CultureInfo aCulture)
		{
			if (aValues == null || aValues.Length < 2)
				return null;

			var mSeries = aValues[0] as BarFragment;
			var mItem = aValues[1];

			if (mItem == null || mSeries == null)
				return null;

			if (mItem == DependencyProperty.UnsetValue || mSeries == DependencyProperty.UnsetValue)
				return null;

			var mPropertyName = this.GetPropertyNameFrom(mSeries.ValueMemberPath, aParameter.ToString());

			var mReturnValue = mItem.GetType().GetProperty(mPropertyName.ToString());

			if (mReturnValue == null)
				return null;

			return mReturnValue.GetValue(mItem, null).ToString();
		}

		private object GetPropertyNameFrom(string aPath, string aParameter)
		{
			var mType = aPath.Split('_').DefaultIfEmpty(String.Empty).FirstOrDefault();

			return mType + aParameter;
		}

		public object[] ConvertBack(object aValues, Type[] targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}
