﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using WpfControls;

namespace XamChartExample
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
		}

		private void BtnOpenUC_OnClick(object sender, RoutedEventArgs e)
		{
			var mWindow = new Window1();
			var mDS = new UKBarChartAusgabeDataSet();
			mDS.ReadXml("Data.xml");
			mDS.AcceptChanges();
			
			var mViewModel = new ChartsViewModel(mDS.Ausgabe1, true);

			mWindow.DataContext = mViewModel;

			mWindow.Show();

		}

		private void Stack_OnAssigningCategoryMarkerStyle(object sender, AssigningCategoryMarkerStyleEventArgs args)
		{
			
		}
	}

	public class TestEmissionsCollection : ObservableCollection<InstalationEmissionDateInformation>
	{
		public TestEmissionsCollection()
		{
			Add(new InstalationEmissionDateInformation("A", 5, "1/1/2012", 1));
			Add(new InstalationEmissionDateInformation("B", 2, "1/1/2012", 1));
			Add(new InstalationEmissionDateInformation("C", 7, "1/1/2012", 1));
			Add(new InstalationEmissionDateInformation("A", 6, "1/2/2012", 1));
			Add(new InstalationEmissionDateInformation("B", 3, "1/2/2012", 1));
			Add(new InstalationEmissionDateInformation("C", 8, "1/2/2012", 1));
			Add(new InstalationEmissionDateInformation("A", 6, "1/3/2012", 1));
			Add(new InstalationEmissionDateInformation("B", 3, "1/3/2012", 1));
			Add(new InstalationEmissionDateInformation("C", 6, "1/3/2012", 1));
			Add(new InstalationEmissionDateInformation("A", 4, "1/4/2012", 1));
			Add(new InstalationEmissionDateInformation("B", 3, "1/4/2012", 1));
			Add(new InstalationEmissionDateInformation("C", 7, "1/4/2012", 1));
		}
	}

	public class InstalationEmissionDateInformation
	{
		public string Installation { get; set; }
		public Decimal Emission { get; set; }
		public string Date { get; set; }
		public Decimal Assignation { get; set; }

		public InstalationEmissionDateInformation(
			string installation,
			Decimal emission,
			string date,
			Decimal assignation)
		{
			Installation = installation;
			Emission = emission;
			Date = date;
			Assignation = assignation;
		}
	}

	public class KeyConverter : IValueConverter
	{

		public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			if (value is string && parameter is string)
			{
				var key = (string)value;
				var param = (string)parameter;

				key = key.Replace(param, "");

				return key;
			}

			return "";
		}

		public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}  


}
